#include "com_ergotech_vib_servers_nativewrapper_NativeTopicListener.h"
#include <map>

using namespace transsecswrapper;

std::map<long long, callback_pointer> topic_listener_callback_map;

JNIEXPORT void JNICALL Java_com_ergotech_vib_servers_nativewrapper_NativeTopicListener_topicValueChanged
  (JNIEnv * env, jobject self, jstring topic, jobject value_object) {
    jclass native_listener_class = env->GetObjectClass(self);
    jmethodID native_listener_get_uuid_mid = env->GetMethodID(native_listener_class, "getListenerUUID", "()[B");
    jbyteArray uuid_byte_array = (jbyteArray)env->CallObjectMethod(self , native_listener_get_uuid_mid);
    jboolean is_copy;
    signed char* uuid_bytes = env->GetByteArrayElements(uuid_byte_array, &is_copy);
    long long uuid = *reinterpret_cast<unsigned long long*>(uuid_bytes);
    if (is_copy == JNI_TRUE) {
        env->ReleaseByteArrayElements(uuid_byte_array,uuid_bytes,JNI_ABORT); // JNI_ABORT -> release without copying back changes
    }
    const char* topic_chars = env->GetStringUTFChars(topic, &is_copy);
    std::string topic_string = std::string(topic_chars);
    if (is_copy == JNI_TRUE) {
        env->ReleaseStringUTFChars(topic, topic_chars);
    }
    topic_listener_callback_map[uuid](topic_string, ValueObject(env, value_object));
}
  
void AddTopicListenerInternal (long long uuid, callback_pointer callback) {
    topic_listener_callback_map[uuid] = callback;
}
